diff --git a/gcc/analyzer/exploded-graph.h b/gcc/analyzer/exploded-graph.h
index 1d31097ec9c..cecbf496af8 100644
--- a/gcc/analyzer/exploded-graph.h
+++ b/gcc/analyzer/exploded-graph.h
@@ -29,6 +29,7 @@ along with GCC; see the file COPYING3.  If not see
 #include "analyzer/sm.h"
 #include "analyzer/program-state.h"
 #include "analyzer/diagnostic-manager.h"
+#include "analyzer/region-model.h"
 
 namespace ana {
 
@@ -47,10 +48,7 @@ class impl_region_model_context : public region_model_context
 			     program_state *new_state,
 			     uncertainty_t *uncertainty,
 			     path_context *path_ctxt,
-
-			     const gimple *stmt,
-			     stmt_finder *stmt_finder = nullptr,
-
+			     const gimple *stmt = nullptr,
 			     bool *out_could_have_done_work = nullptr);
 
   impl_region_model_context (program_state *state,
@@ -58,8 +56,9 @@ class impl_region_model_context : public region_model_context
 			     uncertainty_t *uncertainty,
 			     logger *logger = nullptr);
 
-  bool warn (std::unique_ptr<pending_diagnostic> d,
-	     const stmt_finder *custom_finder = nullptr) final override;
+  bool
+  warn_at (std::unique_ptr<pending_diagnostic> d,
+	   pending_location &&ploc) final override;
   void add_note (std::unique_ptr<pending_note> pn) final override;
   void add_event (std::unique_ptr<checker_event> event) final override;
   void on_svalue_leak (const svalue *) override;
@@ -118,13 +117,15 @@ class impl_region_model_context : public region_model_context
   bool checking_for_infinite_loop_p () const override { return false; }
   void on_unusable_in_infinite_loop () override {}
 
+  pending_location
+  get_pending_location_for_diag () const override;
+
   exploded_graph *m_eg;
   log_user m_logger;
   exploded_node *m_enode_for_diag;
   const program_state *m_old_state;
   program_state *m_new_state;
   const gimple *m_stmt;
-  stmt_finder *m_stmt_finder;
   const extrinsic_state &m_ext_state;
   uncertainty_t *m_uncertainty;
   path_context *m_path_ctxt;
@@ -224,7 +225,7 @@ class exploded_node : public dnode<eg_traits>
        exploded_graph::process_node called on it.  */
     merger,
 
-    /* Node was processed by maybe_process_run_of_before_supernode_enodes.  */
+    /* Node was processed by maybe_process_run_of_enodes.  */
     bulk_merged
   };
   static const char * status_to_str (enum status s);
@@ -247,80 +248,16 @@ class exploded_node : public dnode<eg_traits>
 
   std::unique_ptr<json::object> to_json (const extrinsic_state &ext_state) const;
 
-  /* The result of on_stmt.  */
-  struct on_stmt_flags
-  {
-    on_stmt_flags () : m_terminate_path (false)
-    {}
-
-    static on_stmt_flags terminate_path ()
-    {
-      return on_stmt_flags (true);
-    }
-
-    /* Should we stop analyzing this path (on_stmt may have already
-       added nodes/edges, e.g. when handling longjmp).  */
-    bool m_terminate_path : 1;
-
-  private:
-    on_stmt_flags (bool terminate_path)
-    : m_terminate_path (terminate_path)
-    {}
-  };
-
-  on_stmt_flags on_stmt (exploded_graph &eg,
-			 const supernode *snode,
-			 const gimple *stmt,
-			 program_state *state,
-			 uncertainty_t *uncertainty,
-			 bool *out_could_have_done_work,
-			 path_context *path_ctxt);
-  void on_stmt_pre (exploded_graph &eg,
-		    const gimple *stmt,
-		    program_state *state,
-		    bool *out_terminate_path,
-		    bool *out_unknown_side_effects,
-		    region_model_context *ctxt);
-  void on_stmt_post (const gimple *stmt,
-		     program_state *state,
-		     bool unknown_side_effects,
-		     region_model_context *ctxt);
-
-  on_stmt_flags replay_call_summaries (exploded_graph &eg,
-				       const supernode *snode,
-				       const gcall &call_stmt,
-				       program_state *state,
-				       path_context *path_ctxt,
-				       const function &called_fn,
-				       per_function_data &called_fn_data,
-				       region_model_context *ctxt);
-  void replay_call_summary (exploded_graph &eg,
-			    const supernode *snode,
-			    const gcall &call_stmt,
-			    program_state *state,
-			    path_context *path_ctxt,
-			    const function &called_fn,
-			    call_summary &summary,
-			    region_model_context *ctxt);
-
-  bool on_edge (exploded_graph &eg,
-		const superedge *succ,
-		program_point *next_point,
-		program_state *next_state,
-		uncertainty_t *uncertainty);
   void on_longjmp (exploded_graph &eg,
 		   const gcall &call,
 		   program_state *new_state,
 		   region_model_context *ctxt);
   void on_throw (exploded_graph &eg,
 		 const gcall &call,
+		 const program_point &after_throw_point,
 		 program_state *new_state,
 		 bool is_rethrow,
 		 region_model_context *ctxt);
-  void on_resx (exploded_graph &eg,
-		const gresx &resx,
-		program_state *new_state,
-		region_model_context *ctxt);
 
   void detect_leaks (exploded_graph &eg);
 
@@ -329,6 +266,10 @@ class exploded_node : public dnode<eg_traits>
   {
     return get_point ().get_supernode ();
   }
+  location_t get_location () const
+  {
+    return get_point ().get_location ();
+  }
   function *get_function () const
   {
     return get_point ().get_function ();
@@ -337,8 +278,6 @@ class exploded_node : public dnode<eg_traits>
   {
     return get_point ().get_stack_depth ();
   }
-  const gimple *get_stmt () const { return get_point ().get_stmt (); }
-  const gimple *get_processed_stmt (unsigned idx) const;
 
   const program_state &get_state () const { return m_ps.get_state (); }
 
@@ -414,6 +353,9 @@ class exploded_edge : public dedge<eg_traits>
 
   bool could_do_work_p () const { return m_could_do_work_p; }
 
+  const gimple *maybe_get_stmt () const;
+  const operation *maybe_get_op () const;
+
 private:
   DISABLE_COPY_AND_ASSIGN (exploded_edge);
 
@@ -433,37 +375,70 @@ private:
   bool m_could_do_work_p;
 };
 
-/* Extra data for an exploded_edge that represents dynamic call info ( calls
-   that doesn't have an underlying superedge representing the call ).  */
+/* Extra data for an exploded_edge that represents an interprocedural
+   call.  */
 
-class dynamic_call_info_t : public custom_edge_info
+class interprocedural_call : public custom_edge_info
 {
 public:
-  dynamic_call_info_t (const gcall &dynamic_call,
-  		       const bool is_returning_call = false)
-  : m_dynamic_call (dynamic_call),
-    m_is_returning_call (is_returning_call)
+  interprocedural_call (const gcall &call_stmt,
+			function &callee_fun)
+  : m_call_stmt (call_stmt),
+    m_callee_fun (callee_fun)
   {}
 
-  void print (pretty_printer *pp) const final override
-  {
-    if (m_is_returning_call)
-      pp_string (pp, "dynamic_return");
-    else
-      pp_string (pp, "dynamic_call");
-  }
+  void print (pretty_printer *pp) const final override;
+
+  void get_dot_attrs (const char *&out_style,
+		      const char *&out_color) const final override;
+
+  bool update_state (program_state *state,
+		     const exploded_edge *eedge,
+		     region_model_context *ctxt) const final override;
 
   bool update_model (region_model *model,
 		     const exploded_edge *eedge,
 		     region_model_context *ctxt) const final override;
 
   void add_events_to_path (checker_path *emission_path,
-			   const exploded_edge &eedge) const final override;
+			   const exploded_edge &eedge,
+			   pending_diagnostic &pd) const final override;
+
 private:
-  const gcall &m_dynamic_call;
-  const bool m_is_returning_call;
+  const gcall &m_call_stmt;
+  function &m_callee_fun;
 };
 
+/* Extra data for an exploded_edge that represents an interprocedural
+   return.  */
+
+class interprocedural_return : public custom_edge_info
+{
+public:
+  interprocedural_return (const gcall &call_stmt)
+  : m_call_stmt (call_stmt)
+  {}
+
+  void print (pretty_printer *pp) const final override;
+
+  void get_dot_attrs (const char *&out_style,
+		      const char *&out_color) const final override;
+
+  bool update_state (program_state *state,
+		     const exploded_edge *eedge,
+		     region_model_context *ctxt) const final override;
+
+  bool update_model (region_model *model,
+		     const exploded_edge *eedge,
+		     region_model_context *ctxt) const final override;
+
+  void add_events_to_path (checker_path *emission_path,
+			   const exploded_edge &eedge,
+			   pending_diagnostic &pd) const final override;
+
+private:
+  const gcall &m_call_stmt;
+};
 
 /* Extra data for an exploded_edge that represents a rewind from a
    longjmp to a setjmp (or from a siglongjmp to a sigsetjmp).  */
@@ -487,18 +462,21 @@ public:
 		     region_model_context *ctxt) const final override;
 
   void add_events_to_path (checker_path *emission_path,
-			   const exploded_edge &eedge) const final override;
+			   const exploded_edge &eedge,
+			   pending_diagnostic &pd) const final override;
 
-  const program_point &get_setjmp_point () const
+  program_point
+  get_point_before_setjmp () const
   {
-    const program_point &origin_point = get_enode_origin ()->get_point ();
-
-    /* "origin_point" ought to be before the call to "setjmp".  */
-    gcc_assert (origin_point.get_kind () == PK_BEFORE_STMT);
-
-    /* TODO: assert that it's the final stmt in its supernode.  */
+    return get_enode_origin ()->get_point ();
+  }
 
-    return origin_point;
+  program_point
+  get_point_after_setjmp () const
+  {
+    const program_point &origin_point = get_enode_origin ()->get_point ();
+    return program_point (m_setjmp_record.m_sedge->m_dest,
+			  origin_point.get_call_string ());
   }
 
   const gcall &get_setjmp_call () const
@@ -531,7 +509,7 @@ struct stats
 
   int get_total_enodes () const;
 
-  int m_num_nodes[NUM_POINT_KINDS];
+  int m_num_nodes;
   int m_node_reuse_count;
   int m_node_reuse_after_merge_count;
   int m_num_supernodes;
@@ -686,7 +664,6 @@ struct per_function_data
   auto_vec<call_summary *> m_summaries;
 };
 
-
 /* The strongly connected components of a supergraph.
    In particular, this allows us to compute a partial ordering
    of supernodes.  */
@@ -709,15 +686,15 @@ private:
   struct per_node_data
   {
     per_node_data ()
-      : m_index (-1), m_lowlink (-1), m_on_stack (false)
+    : m_id (-1), m_lowlink (-1), m_on_stack (false)
     {}
 
-    int m_index;
+    int m_id;
     int m_lowlink;
     bool m_on_stack;
   };
 
-  void strong_connect (unsigned index);
+  void strong_connect (unsigned index, logger *logger);
 
   const supergraph &m_sg;
   auto_vec<unsigned> m_stack;
@@ -744,7 +721,7 @@ public:
   void add_node (exploded_node *enode);
   int get_scc_id (const supernode &snode) const
   {
-    return m_scc.get_scc_id (snode.m_index);
+    return m_scc.get_scc_id (snode.m_id);
   }
 
   std::unique_ptr<json::object> to_json () const;
@@ -780,7 +757,7 @@ private:
       const supernode *snode = enode->get_supernode ();
       if (snode == nullptr)
 	return 0;
-      return m_worklist.m_scc.get_scc_id (snode->m_index);
+      return m_worklist.m_scc.get_scc_id (snode->m_id);
     }
 
     const worklist &m_worklist;
@@ -829,17 +806,9 @@ public:
 
   void build_initial_worklist ();
   void process_worklist ();
-  bool maybe_process_run_of_before_supernode_enodes (exploded_node *node);
+  bool maybe_process_run_of_enodes (exploded_node *node);
   void process_node (exploded_node *node);
 
-  bool maybe_create_dynamic_call (const gcall &call,
-                                  tree fn_decl,
-                                  exploded_node *node,
-                                  program_state next_state,
-                                  program_point &next_point,
-                                  uncertainty_t *uncertainty,
-                                  logger *logger);
-
   exploded_node *get_or_create_node (const program_point &point,
 				     const program_state &state,
 				     exploded_node *enode_for_diag,
@@ -863,7 +832,6 @@ public:
   void save_diagnostic (const state_machine &sm,
 			const exploded_node *enode,
 			const supernode *node, const gimple *stmt,
-			stmt_finder *finder,
 			tree var, state_machine::state_t state,
 			pending_diagnostic *d);
 
@@ -954,8 +922,6 @@ private:
 
   call_string_data_map_t m_per_call_string_data;
 
-  auto_vec<int> m_PK_AFTER_SUPERNODE_per_snode;
-
   /* Functions with a top-level enode, to make add_function_entry
      be idempotent, for use in handling callbacks.  */
   hash_set<function *> m_functions_with_enodes;
@@ -996,17 +962,15 @@ class feasibility_problem
 public:
   feasibility_problem (unsigned eedge_idx,
 		       const exploded_edge &eedge,
-		       const gimple *last_stmt,
 		       std::unique_ptr<rejected_constraint> rc)
   : m_eedge_idx (eedge_idx), m_eedge (eedge),
-    m_last_stmt (last_stmt), m_rc (std::move (rc))
+    m_rc (std::move (rc))
   {}
 
   void dump_to_pp (pretty_printer *pp) const;
 
   unsigned m_eedge_idx;
   const exploded_edge &m_eedge;
-  const gimple *m_last_stmt;
   std::unique_ptr<rejected_constraint> m_rc;
 };
 
@@ -1030,7 +994,9 @@ public:
 			      std::unique_ptr<rejected_constraint> *out_rc);
   void update_for_stmt (const gimple *stmt);
 
+  region_model &get_model () { return m_model; }
   const region_model &get_model () const { return m_model; }
+  auto_sbitmap &get_snodes_visited () { return m_snodes_visited; }
   const auto_sbitmap &get_snodes_visited () const { return m_snodes_visited; }
 
   void dump_to_pp (pretty_printer *pp, bool simple, bool multiline) const;
@@ -1044,20 +1010,6 @@ private:
 
 typedef shortest_paths<eg_traits, exploded_path> shortest_exploded_paths;
 
-/* Abstract base class for use when passing nullptr as the stmt for
-   a possible warning, allowing the choice of stmt to be deferred
-   until after we have an emission path (and know we're emitting a
-   warning).  */
-
-class stmt_finder
-{
-public:
-  virtual ~stmt_finder () {}
-  virtual std::unique_ptr<stmt_finder> clone () const = 0;
-  virtual const gimple *find_stmt (const exploded_path &epath) = 0;
-  virtual void update_event_loc_info (event_loc_info &) = 0;
-};
-
 // TODO: split the above up?
 
 } // namespace ana
diff --git a/gcc/analyzer/feasible-graph.cc b/gcc/analyzer/feasible-graph.cc
index 25a97e7c12c..36272f83661 100644
--- a/gcc/analyzer/feasible-graph.cc
+++ b/gcc/analyzer/feasible-graph.cc
@@ -81,7 +81,9 @@ feasible_node::dump_dot (graphviz_out *gv,
   m_state.get_model ().dump_to_pp (pp, true, true);
   pp_newline (pp);
 
+#if 0
   m_inner_node->dump_processed_stmts (pp);
+#endif
   m_inner_node->dump_saved_diagnostics (pp);
 
   pp_write_text_as_dot_label_to_stream (pp, /*for_record=*/true);
@@ -90,36 +92,6 @@ feasible_node::dump_dot (graphviz_out *gv,
   pp_flush (pp);
 }
 
-/* Attempt to get the region_model for this node's state at TARGET_STMT.
-   Return true and write to *OUT if found.
-   Return false if there's a problem.  */
-
-bool
-feasible_node::get_state_at_stmt (const gimple *target_stmt,
-				  region_model *out) const
-{
-  if (!target_stmt)
-    return false;
-
-  feasibility_state result (m_state);
-
-  /* Update state for the stmts that were processed in each enode.  */
-  for (unsigned stmt_idx = 0; stmt_idx < m_inner_node->m_num_processed_stmts;
-       stmt_idx++)
-    {
-      const gimple *stmt = m_inner_node->get_processed_stmt (stmt_idx);
-      if (stmt == target_stmt)
-	{
-	  *out = result.get_model ();
-	  return true;
-	}
-      result.update_for_stmt (stmt);
-    }
-
-  /* TARGET_STMT not found; wrong node?  */
-  return false;
-}
-
 /* Implementation of dump_dot vfunc for infeasible_node.
    In particular, show the rejected constraint.  */
 
diff --git a/gcc/analyzer/impl-sm-context.h b/gcc/analyzer/impl-sm-context.h
new file mode 100644
index 00000000000..f2884c04c9b
--- /dev/null
+++ b/gcc/analyzer/impl-sm-context.h
@@ -0,0 +1,284 @@
+/* Concrete implementation of sm_context.
+   Copyright (C) 2019-2025 Free Software Foundation, Inc.
+   Contributed by David Malcolm <dmalcolm@redhat.com>.
+
+This file is part of GCC.
+
+GCC is free software; you can redistribute it and/or modify it
+under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 3, or (at your option)
+any later version.
+
+GCC is distributed in the hope that it will be useful, but
+WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with GCC; see the file COPYING3.  If not see
+<http://www.gnu.org/licenses/>.  */
+
+#ifndef GCC_ANALYZER_IMPL_SM_CONTEXT
+#define GCC_ANALYZER_IMPL_SM_CONTEXT
+
+namespace ana {
+
+/* Concrete implementation of sm_context, wiring it up to the rest of this
+   file.  */
+
+class impl_sm_context : public sm_context
+{
+public:
+  impl_sm_context (exploded_graph &eg,
+		   int sm_idx,
+		   const state_machine &sm,
+		   exploded_node *enode_for_diag,
+		   const program_state *old_state,
+		   program_state *new_state,
+		   const sm_state_map *old_smap,
+		   sm_state_map *new_smap,
+		   path_context *path_ctxt,
+		   bool unknown_side_effects = false)
+  : sm_context (sm_idx, sm),
+    m_logger (eg.get_logger ()),
+    m_eg (eg), m_enode_for_diag (enode_for_diag),
+    m_old_state (old_state), m_new_state (new_state),
+    m_old_smap (old_smap), m_new_smap (new_smap),
+    m_path_ctxt (path_ctxt),
+    m_unknown_side_effects (unknown_side_effects)
+  {
+  }
+
+  logger *get_logger () const { return m_logger.get_logger (); }
+
+  tree get_fndecl_for_call (const gcall &call) final override
+  {
+    impl_region_model_context old_ctxt
+      (m_eg, m_enode_for_diag, nullptr, nullptr, nullptr/*m_enode->get_state ()*/,
+       nullptr, &call);
+    region_model *model = m_new_state->m_region_model;
+    return model->get_fndecl_for_call (call, &old_ctxt);
+  }
+
+  state_machine::state_t get_state (tree var) final override
+  {
+    logger * const logger = get_logger ();
+    LOG_FUNC (logger);
+    /* Use nullptr ctxt on this get_rvalue call to avoid triggering
+       uninitialized value warnings.  */
+    const svalue *var_old_sval
+      = m_old_state->m_region_model->get_rvalue (var, nullptr);
+
+    state_machine::state_t current
+      = m_old_smap->get_state (var_old_sval, m_eg.get_ext_state ());
+    return current;
+  }
+  state_machine::state_t get_state (const svalue *sval) final override
+  {
+    logger * const logger = get_logger ();
+    LOG_FUNC (logger);
+    state_machine::state_t current
+      = m_old_smap->get_state (sval, m_eg.get_ext_state ());
+    return current;
+  }
+
+
+  void set_next_state (tree var,
+		       state_machine::state_t to,
+		       tree origin) final override
+  {
+    logger * const logger = get_logger ();
+    LOG_FUNC (logger);
+    const svalue *var_new_sval
+      = m_new_state->m_region_model->get_rvalue (var, nullptr);
+    const svalue *origin_new_sval
+      = m_new_state->m_region_model->get_rvalue (origin, nullptr);
+
+    /* We use the new sval here to avoid issues with uninitialized values.  */
+    state_machine::state_t current
+      = m_old_smap->get_state (var_new_sval, m_eg.get_ext_state ());
+    if (logger)
+      logger->log ("%s: state transition of %qE: %s -> %s",
+		   m_sm.get_name (),
+		   var,
+		   current->get_name (),
+		   to->get_name ());
+    m_new_smap->set_state (m_new_state->m_region_model, var_new_sval,
+			   to, origin_new_sval, m_eg.get_ext_state ());
+  }
+
+  void set_next_state (const svalue *sval,
+		       state_machine::state_t to,
+		       tree origin) final override
+  {
+    logger * const logger = get_logger ();
+    LOG_FUNC (logger);
+    impl_region_model_context old_ctxt
+      (m_eg, m_enode_for_diag, nullptr, nullptr, nullptr/*m_enode->get_state ()*/,
+       nullptr, nullptr);
+
+    const svalue *origin_new_sval
+      = m_new_state->m_region_model->get_rvalue (origin, nullptr);
+
+    state_machine::state_t current
+      = m_old_smap->get_state (sval, m_eg.get_ext_state ());
+    if (logger)
+      {
+	logger->start_log_line ();
+	logger->log_partial ("%s: state transition of ",
+			     m_sm.get_name ());
+	sval->dump_to_pp (logger->get_printer (), true);
+	logger->log_partial (": %s -> %s",
+			     current->get_name (),
+			     to->get_name ());
+	logger->end_log_line ();
+      }
+    m_new_smap->set_state (m_new_state->m_region_model, sval,
+			   to, origin_new_sval, m_eg.get_ext_state ());
+  }
+
+  void warn (tree var,
+	     std::unique_ptr<pending_diagnostic> d) final override
+  {
+    LOG_FUNC (get_logger ());
+    gcc_assert (d);
+    const svalue *var_old_sval
+      = m_old_state->m_region_model->get_rvalue (var, nullptr);
+    state_machine::state_t current
+      = (var
+	 ? m_old_smap->get_state (var_old_sval, m_eg.get_ext_state ())
+	 : m_old_smap->get_global_state ());
+    bool terminate_path = d->terminate_path_p ();
+    pending_location ploc (m_enode_for_diag);
+    m_eg.get_diagnostic_manager ().add_diagnostic
+      (&m_sm, std::move (ploc),
+       var, var_old_sval, current, std::move (d));
+    if (m_path_ctxt
+	&& terminate_path
+	&& flag_analyzer_suppress_followups)
+      m_path_ctxt->terminate_path ();
+  }
+
+  void warn (const svalue *sval,
+	     std::unique_ptr<pending_diagnostic> d) final override
+  {
+    LOG_FUNC (get_logger ());
+    gcc_assert (d);
+    state_machine::state_t current
+      = (sval
+	 ? m_old_smap->get_state (sval, m_eg.get_ext_state ())
+	 : m_old_smap->get_global_state ());
+    bool terminate_path = d->terminate_path_p ();
+    pending_location ploc (m_enode_for_diag);
+    m_eg.get_diagnostic_manager ().add_diagnostic
+      (&m_sm, std::move (ploc),
+       NULL_TREE, sval, current, std::move (d));
+    if (m_path_ctxt
+	&& terminate_path
+	&& flag_analyzer_suppress_followups)
+      m_path_ctxt->terminate_path ();
+  }
+
+  /* Hook for picking more readable trees for SSA names of temporaries,
+     so that rather than e.g.
+       "double-free of '<unknown>'"
+     we can print:
+       "double-free of 'inbuf.data'".  */
+
+  tree get_diagnostic_tree (tree expr) final override
+  {
+    /* Only for SSA_NAMEs of temporaries; otherwise, return EXPR, as it's
+       likely to be the least surprising tree to report.  */
+    if (TREE_CODE (expr) != SSA_NAME)
+      return expr;
+    if (SSA_NAME_VAR (expr) != NULL)
+      return expr;
+
+    gcc_assert (m_new_state);
+    const svalue *sval = m_new_state->m_region_model->get_rvalue (expr, nullptr);
+    /* Find trees for all regions storing the value.  */
+    if (tree t = m_new_state->m_region_model->get_representative_tree (sval))
+      return t;
+    else
+      return expr;
+  }
+
+  tree get_diagnostic_tree (const svalue *sval) final override
+  {
+    return m_new_state->m_region_model->get_representative_tree (sval);
+  }
+
+  state_machine::state_t get_global_state () const final override
+  {
+    return m_old_state->m_checker_states[m_sm_idx]->get_global_state ();
+  }
+
+  void set_global_state (state_machine::state_t state) final override
+  {
+    m_new_state->m_checker_states[m_sm_idx]->set_global_state (state);
+  }
+
+  void clear_all_per_svalue_state () final override
+  {
+    m_new_state->m_checker_states[m_sm_idx]->clear_all_per_svalue_state ();
+  }
+
+  void on_custom_transition (custom_transition *transition) final override
+  {
+    transition->impl_transition (&m_eg,
+				 const_cast<exploded_node *> (m_enode_for_diag),
+				 m_sm_idx);
+  }
+
+  tree is_zero_assignment (const gimple *stmt) final override
+  {
+    const gassign *assign_stmt = dyn_cast <const gassign *> (stmt);
+    if (!assign_stmt)
+     return NULL_TREE;
+    impl_region_model_context old_ctxt
+      (m_eg, m_enode_for_diag, m_old_state, m_new_state, nullptr, nullptr, stmt);
+    if (const svalue *sval
+	= m_new_state->m_region_model->get_gassign_result (assign_stmt,
+							    &old_ctxt))
+      if (tree cst = sval->maybe_get_constant ())
+	if (::zerop(cst))
+	  return gimple_assign_lhs (assign_stmt);
+    return NULL_TREE;
+  }
+
+  path_context *get_path_context () const final override
+  {
+    return m_path_ctxt;
+  }
+
+  bool unknown_side_effects_p () const final override
+  {
+    return m_unknown_side_effects;
+  }
+
+  const program_state *get_old_program_state () const final override
+  {
+    return m_old_state;
+  }
+
+  const program_state *get_new_program_state () const final override
+  {
+    return m_new_state;
+  }
+
+  log_user m_logger;
+  exploded_graph &m_eg;
+  exploded_node *m_enode_for_diag;
+  const program_state *m_old_state;
+  program_state *m_new_state;
+  const sm_state_map *m_old_smap;
+  sm_state_map *m_new_smap;
+  path_context *m_path_ctxt;
+
+  /* Are we handling an external function with unknown side effects?  */
+  bool m_unknown_side_effects;
+};
+
+} // namespace ana
+
+#endif /* GCC_ANALYZER_IMPL_SM_CONTEXT */
